VERSION 5.00
Begin VB.Form frmMMSettingSources 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Synchronization Settings"
   ClientHeight    =   5670
   ClientLeft      =   120
   ClientTop       =   510
   ClientWidth     =   4815
   Icon            =   "frmMMSettingSources.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5670
   ScaleWidth      =   4815
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.OptionButton Option3 
      BackColor       =   &H80000005&
      Caption         =   "Debug"
      Height          =   252
      Left            =   3600
      TabIndex        =   17
      Top             =   4440
      Width           =   972
   End
   Begin VB.OptionButton Option2 
      BackColor       =   &H80000005&
      Caption         =   "Info"
      Height          =   252
      Left            =   2640
      TabIndex        =   16
      Top             =   4440
      Width           =   735
   End
   Begin VB.OptionButton Option1 
      BackColor       =   &H80000005&
      Caption         =   "None"
      Height          =   252
      Left            =   1560
      TabIndex        =   15
      Top             =   4440
      Width           =   972
   End
   Begin VB.ComboBox ComboCalendar 
      Height          =   315
      Left            =   1920
      Style           =   2  'Dropdown List
      TabIndex        =   11
      Top             =   1320
      Width           =   2535
   End
   Begin VB.CommandButton callRemoteSettings 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Remote Settings"
      Height          =   372
      Left            =   2880
      MaskColor       =   &H00FFFFFF&
      TabIndex        =   6
      Top             =   3240
      Visible         =   0   'False
      Width           =   1572
   End
   Begin VB.Frame Frame1 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Synchronization Settings"
      Height          =   3615
      Left            =   120
      TabIndex        =   7
      Top             =   240
      Width           =   4575
      Begin VB.CheckBox encryptionCheck 
         BackColor       =   &H80000005&
         Caption         =   "Encryption"
         Height          =   375
         Left            =   240
         TabIndex        =   14
         Top             =   3000
         Width           =   1215
      End
      Begin VB.ComboBox ComboNotes 
         Height          =   315
         Left            =   1800
         Style           =   2  'Dropdown List
         TabIndex        =   13
         Top             =   2280
         Width           =   2535
      End
      Begin VB.ComboBox ComboTasks 
         Height          =   315
         Left            =   1800
         Style           =   2  'Dropdown List
         TabIndex        =   12
         Top             =   1680
         Width           =   2535
      End
      Begin VB.ComboBox ComboContacts 
         Height          =   315
         ItemData        =   "frmMMSettingSources.frx":058A
         Left            =   1800
         List            =   "frmMMSettingSources.frx":058C
         Style           =   2  'Dropdown List
         TabIndex        =   10
         Top             =   480
         Width           =   2535
      End
      Begin VB.CheckBox calendarsCheck 
         BackColor       =   &H00FFFFFF&
         Caption         =   "Calendar"
         Height          =   492
         Left            =   240
         TabIndex        =   3
         Top             =   960
         Width           =   1332
      End
      Begin VB.CheckBox contactsCheck 
         BackColor       =   &H00FFFFFF&
         Caption         =   "Contacts"
         Height          =   492
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   1332
      End
      Begin VB.CheckBox tasksCheck 
         BackColor       =   &H00FFFFFF&
         Caption         =   "Tasks"
         Height          =   492
         Left            =   240
         TabIndex        =   4
         Top             =   1560
         Width           =   1332
      End
      Begin VB.CheckBox notesCheck 
         BackColor       =   &H00FFFFFF&
         Caption         =   "Notes"
         Height          =   492
         Left            =   240
         TabIndex        =   5
         Top             =   2160
         Width           =   1332
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Cancel"
      Height          =   372
      Left            =   3360
      TabIndex        =   1
      Top             =   5160
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "OK"
      Height          =   372
      Left            =   1680
      TabIndex        =   0
      Top             =   5160
      Width           =   1335
   End
   Begin VB.Frame Frame2 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Other Settings"
      Height          =   855
      Left            =   120
      TabIndex        =   8
      Top             =   4080
      Width           =   4575
      Begin VB.Label Label1 
         BackColor       =   &H80000005&
         Caption         =   "Log level"
         Height          =   252
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   972
      End
   End
End
Attribute VB_Name = "frmMMSettingSources"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Copyright (C) 2003-2006 Funambol
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'****************************************************************
'*Form:    frmMMSettingSources.frm                              *
'****************************************************************

' This is the number of syncModes implemented
' (fast/refresh-client/refresh-server/one-way-client/one-way-server)
Const syncModesCount As Integer = 5
' Strings referred
Dim syncModes(syncModesCount) As String

Dim syncContactsMode As String
Dim syncCalendarsMode As String
Dim syncTasksMode As String
Dim syncNotesMode As String

Dim logMode As String
Dim encryptionMode As String
Dim encodingMode As String



' Load Configurations from Windows registry (syncMode for each source)
' --------------------------------------------------------------------
Private Sub Form_Load()
    
    Load_SyncModes
    
    Load_Contacts
    Load_Calendars
    Load_Tasks
    Load_Notes
    
    Load_LogLevel
    Load_EncryptionMode
    Load_Combos
    
    'checkVisible
    checkElementVisible
    
    'Center the form in the screen
    Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
    
End Sub

Private Sub Load_SyncModes()

    'These strings refers exactly to strings stored in register key "sync"
    syncModes(0) = mdMMVariables.TWO_WAY
    syncModes(1) = mdMMVariables.REFRESH_SERVER
    syncModes(2) = mdMMVariables.REFRESH_CLIENT
    syncModes(3) = mdMMVariables.ONE_WAY_SERVER
    syncModes(4) = mdMMVariables.ONE_WAY_CLIENT
    
    'Note: alternatively we can load here syncModes from the specific key in register

End Sub
Private Sub Load_Calendars()
    Dim value As String
    value = Space(DIM_VALUE)
    
    getRegSourceProperty SYNCAPPOINTMENTS, PROPERTY_SOURCE_SYNC, value, DIM_VALUE
    
    If Trim(value) <> NONE Then
        calendarsCheck.value = 1
    Else
        calendarsCheck.value = 0
    End If
    
    ' The value from register key
    syncCalendarsMode = Trim(value)
    
End Sub

Private Sub Load_Contacts()
    Dim value As String
    value = Space(DIM_VALUE)
    
    getRegSourceProperty SYNCCONTACTS, PROPERTY_SOURCE_SYNC, value, DIM_VALUE
    
    If Trim(value) <> NONE Then
        contactsCheck.value = 1
    Else
        contactsCheck.value = 0
    End If
    
    ' The value from register key
    syncContactsMode = Trim(value)
    
End Sub
Private Sub Load_Tasks()
    Dim value As String
    value = Space(DIM_VALUE)
    
    getRegSourceProperty SYNCTASKS, PROPERTY_SOURCE_SYNC, value, DIM_VALUE
    
    If Trim(value) <> NONE Then
        tasksCheck.value = 1
    Else
        tasksCheck.value = 0
    End If

    ' The value from register key
    syncTasksMode = Trim(value)
    
End Sub
Private Sub Load_Notes()
    Dim value As String
    value = Space(DIM_VALUE)
    
    getRegSourceProperty SYNCNOTES, PROPERTY_SOURCE_SYNC, value, DIM_VALUE
    
    If Trim(value) <> NONE Then
        notesCheck.value = 1
    Else
        notesCheck.value = 0
    End If
    
    ' The value from register key
    syncNotesMode = Trim(value)
    
    End Sub

Private Sub Load_LogLevel()
    Dim value As String
    value = Space(DIM_VALUE)
    
    getRegProperty "", PROPERTY_LOG_LEVEL, value, DIM_VALUE
    
    If Trim(value) = 0 Then
        logLevel = 0
        Option1.value = True
    ElseIf Trim(value) = 1 Then
        logLevel = 1
        Option2.value = True
    ElseIf Trim(value) = 2 Then
        logLevel = 2
        Option3.value = True
    End If
       
    
End Sub

Private Sub Load_EncryptionMode()
    Dim value As String
    value = Space(16)
    
    getRegConfigProperty SPDM_ENCRYPTION, value, 16
    
    If Trim(value) = mdMMVariables.ENCRYPTION_TRUE Then
       encryptionCheck.value = 1
    Else
       encryptionCheck.value = 0
    End If
    
End Sub

Private Sub Load_Combos()
    
    ' These are strings displayed in combo-boxes
    Dim syncModeLabels(syncModesCount) As String
    Dim i As Integer
    
    syncModeLabels(0) = "Normal"                        ' Fast Sync (two-way)
    syncModeLabels(1) = "Replace Local Data"            ' Refresh from Server
    syncModeLabels(2) = "Replace Remote Data"           ' Refresh from Client
    syncModeLabels(3) = "Update Local Data"             ' One-Way from Server
    syncModeLabels(4) = "Update Remote Data"            ' One-Way from Client


    ' Add items to combo-box
    For i = 0 To syncModesCount - 1
        ComboContacts.addItem syncModeLabels(i), i
        ComboCalendar.addItem syncModeLabels(i), i
        ComboTasks.addItem syncModeLabels(i), i
        ComboNotes.addItem syncModeLabels(i), i
    Next i
    
       
    ' Initialize combo.text, combo.ListIndex (Default = Normal = index 0)
    ComboContacts.text = syncModeLabels(0)
    ComboCalendar.text = syncModeLabels(0)
    ComboTasks.text = syncModeLabels(0)
    ComboNotes.text = syncModeLabels(0)
    ComboContacts.ListIndex = 0
    ComboCalendar.ListIndex = 0
    ComboTasks.ListIndex = 0
    ComboNotes.ListIndex = 0
    
    'Compare current syncMode with used syncModes, set combo.text
    For i = 0 To syncModesCount - 1
        If syncContactsMode = syncModes(i) Then
            ComboContacts.text = syncModeLabels(i)
            ComboContacts.ListIndex = i
            Exit For
        End If
    Next i
    For i = 0 To syncModesCount - 1
        If syncCalendarsMode = syncModes(i) Then
            ComboCalendar.text = syncModeLabels(i)
            ComboCalendar.ListIndex = i
            Exit For
        End If
    Next i
    For i = 0 To syncModesCount - 1
        If syncTasksMode = syncModes(i) Then
            ComboTasks.text = syncModeLabels(i)
            ComboTasks.ListIndex = i
            Exit For
        End If
    Next i
    For i = 0 To syncModesCount - 1
        If syncNotesMode = syncModes(i) Then
            ComboNotes.text = syncModeLabels(i)
            ComboNotes.ListIndex = i
            Exit For
        End If
    Next i
    
    'Set combos enabled/disabled due to check-boxes
    If contactsCheck.value = 0 Then
        ComboContacts.Enabled = False
    End If
    If calendarsCheck.value = 0 Then
        ComboCalendar.Enabled = False
    End If
    If tasksCheck.value = 0 Then
        ComboTasks.Enabled = False
    End If
    If notesCheck.value = 0 Then
        ComboNotes.Enabled = False
    End If
    
End Sub


Private Sub cancelControl_Click(Index As Integer)
    Unload Me
End Sub

Private Sub callRemoteSettings_Click()
 frmMMRemoteSettings.Show 1
End Sub


Private Sub Command1_Click()
    Save
    Unload Me
End Sub

Private Sub Command2_Click()
    Unload Me
End Sub


' Save configuration in Windows registry (syncMode for each source)
' -----------------------------------------------------------------
Private Sub Save()
    Dim ret As Long
    
    ' SyncMode
    If contactsCheck.value = 0 Then
        syncContactsMode = mdMMVariables.NONE
    Else
        syncContactsMode = syncModes(ComboContacts.ListIndex)
    End If
    
    If calendarsCheck.value = 0 Then
        syncCalendarsMode = mdMMVariables.NONE
    Else
        syncCalendarsMode = syncModes(ComboCalendar.ListIndex)
    End If
    
    If tasksCheck.value = 0 Then
        syncTasksMode = mdMMVariables.NONE
    Else
        syncTasksMode = syncModes(ComboTasks.ListIndex)
    End If
    
    If notesCheck.value = 0 Then
        syncNotesMode = mdMMVariables.NONE
    Else
        syncNotesMode = syncModes(ComboNotes.ListIndex)
    End If
    
    'LogLevel
    If Option1.value = True Then
        logMode = "0"
    ElseIf Option2.value = True Then
        logMode = "1"
    ElseIf Option3.value = True Then
        logMode = "2"
    End If
    
    'Encryption
    If encryptionCheck.value = 0 Then
        encryptionMode = mdMMVariables.ENCRYPTION_FALSE
    Else
        encryptionMode = mdMMVariables.ENCRYPTION_TRUE
    End If
    
    'MsgBox ("Contacts syncMode = " + syncContactsMode + Chr(13) + "Calendar syncMode = " + _
    '        syncCalendarsMode + Chr(13) + "Tasks syncMode = " + syncTasksMode + Chr(13) + _
    '        "Notes syncMode = " + syncNotesMode)

    
    ' Writing configs to register
    ret = setRegSourceProperty(SYNCCONTACTS, PROPERTY_SOURCE_SYNC, syncContactsMode)
    
    If ret <> 0 Then
        GoTo Error_saving_config
    End If
    
    ret = setRegSourceProperty(SYNCAPPOINTMENTS, PROPERTY_SOURCE_SYNC, syncCalendarsMode)
    ret = setRegSourceProperty(SYNCTASKS, PROPERTY_SOURCE_SYNC, syncTasksMode)
    ret = setRegSourceProperty(SYNCNOTES, PROPERTY_SOURCE_SYNC, syncNotesMode)
    
    If ret <> 0 Then
        GoTo Error_saving_config
    End If
    
    ret = setRegProperty("", PROPERTY_LOG_LEVEL, logMode)
    ret = setRegConfigProperty(SPDM_ENCRYPTION, encryptionMode)
    
    If ret <> 0 Then
        GoTo Error_saving_config
    End If
    
    logToDebug mdMMVariables.CONF_SAVE_SUCCESFULLY

    Exit Sub
    
Error_saving_config:
    MsgBox mdMMVariables.CONF_NOT_SAVE_SUCCESFULLY
    
End Sub




Private Sub checkElementVisible()
    ' check remoteSettings property XaQ
    Dim ret As Integer
    Dim value As String
    value = Space(DIM_VALUE)
    
    ret = getRegProperty("", PROPERTY_REMOTE, value, DIM_VALUE)
    If ret <> 0 Then
        MsgBox CONF_NOT_SAVE_SUCCESFULLY
        Exit Sub
    End If
    
    If Trim(value) = "0" Then
        frmMMSettingSources.callRemoteSettings.Visible = False
    ElseIf Trim(value) = "1" Then
        frmMMSettingSources.callRemoteSettings.Visible = True
    End If
End Sub

Private Sub saveControl_Click(Index As Integer)
    Save
    Unload Me
End Sub


Private Sub contactsCheck_Click()
    If contactsCheck.value = 0 Then
        ComboContacts.Enabled = False
    Else
        ComboContacts.Enabled = True
    End If
End Sub

Private Sub calendarsCheck_Click()
    If calendarsCheck.value = 0 Then
        ComboCalendar.Enabled = False
    Else
        ComboCalendar.Enabled = True
    End If
End Sub

Private Sub tasksCheck_Click()
    If tasksCheck.value = 0 Then
        ComboTasks.Enabled = False
    Else
        ComboTasks.Enabled = True
    End If
End Sub

Private Sub notesCheck_Click()
    If notesCheck.value = 0 Then
        ComboNotes.Enabled = False
    Else
        ComboNotes.Enabled = True
    End If
End Sub

